#ifndef SHELLTR_H
#define SHELLTR_H

#include "alias.h"
struct matrix;
struct vector;
struct ivector;

/**
   shell triangular element
   resulting matrices are composed from plane triangular element
   with rotational degrees of freedom and from constant curve triangle
   
*/
class shelltr
{
 public:
  shelltr (void);
  ~shelltr (void);

  void tran_mat(vector &x, vector &y, matrix &tran, vector &gx, vector &gy, vector &gz);
  void tran_mat_old(vector &x, vector &y, matrix &tran, vector &gx, vector &gy, vector &gz);
  void transf_matrix (ivector &nodes,matrix &tmat);
  void res_stiffness_matrix (long eid,matrix &sm);

  void res_ip_strains (long lcid,long eid);
  void res_ip_stresses (long lcid,long eid);
  void compute_nlstress (long lcid,long eid);
  void compute_nlstressincr (long lcid,long eid);
  void res_internal_forces (long lcid,long eid,vector &ifor);

  void nod_strains_ip (long lcid,long eid);
  void strains (long lcid,long eid);
  void nod_stresses_ip (long lcid,long eid);
  void stresses (long lcid,long eid);
  void inicipval(long eid, long ri, long ci, matrix &nodval, inictype *ictn);


  //  number of DOFs on the element
  long ndofe;
  //  number of nodes on one element
  long nne;
  //  number of edges on one element
  long ned;
  //  number of nodes on one edge
  long nned;
  ///  total number of integration points on element
  long tnip;
  //  order of integration of stiffness matrix
  long **intordsm;
  //  total number of components of stress and strain tensors
  long tncomp,tncomps,tncompd;
  //  number of components of stress and strain tensors plane
  long *ncomps;
  //  number of components of stress and strain tensors plate
  long *ncompd;
  //  number of approximated functions on the element
  long napfun;
  //  array of numbers of DOFs
  long *dofe;
  //  number of integration points for stiffness matrix
  long **nip;
  //  number of blocks
  long nb;
  //  stress/strain state
  strastrestate ssst;
  
};

#endif
